<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Communication Using Exact Data-Flow information</TITLE>
<link href="lic_16.html" rel=Next>
<link href="lic_14.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_14.html">previous</A>, <A HREF="lic_16.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC15" HREF="lic_toc.html#TOC15">Communication Using Exact Data-Flow information</A></H3>


<PRE>
 A(N, N)
 do i = 1, U
   do j = 1, i - 1
     A(i, j) = A(j, i)
   enddo
 enddo
</PRE>

<P>
<A NAME="IDX167"></A>

</P>
<P>
For the above code, which transposes an array, exact data-flow
information is used to find communication.  Exact data-flow information,
which can be obtained using Last Write Trees, will provide
producer-consumer relationships between read and write accesses.
Instead of data decomposition as in the owner computes rule (see section <A HREF="lic_12.html#SEC12">Owner Computes Rule</A>), computation distribution is supplied.

</P>
<P>
<A NAME="IDX168"></A>
<A NAME="IDX169"></A>
<A NAME="IDX170"></A>
<A NAME="IDX171"></A>
<A NAME="IDX172"></A>
<A NAME="IDX173"></A>
<A NAME="IDX174"></A>
<A NAME="IDX175"></A>
<A NAME="IDX176"></A>

</P>

<PRE>
iter = [ 1 &#60;= ir &#60;= U 
         1 &#60;= jr &#60;= ir - 1 ]

decompr =  [ L*Pr &#60;= ir &#60; L*Pr + L ]
decompw =  [ L*Pw &#60;= iw &#60; L*Pw + L ]

lwt = [ iw = jr
        jw = ir ]

// Computation decomposition
#loop = { iter, decompr }
#loop = loop.order(U Pr ir jr)
#loop = loop.rename(U P i j)
loop.code(2)

// Communication 1
#comm1 = { iter, decompr, decompw, lwt 
           [ Pr &#62; Pw ] }
#comm1 = comm1.order(U Pr ir jr Pw iw jw)
#comm1r = comm1.rename(U P i j Pw iw jw)
comm1r.code(2)
#comm1 = comm1.order(U Pw iw jw Pr ir jr)
#comm1w = comm1.rename(U P i j Pr ir jr)
comm1w.code(2)

// Communication 2
#comm2 = { iter, decompr, decompw, lwt
          [ Pr &#60; Pw ] }
#comm2 = comm.order(U Pr ir jr Pw iw jw)
#comm2r = comm2.rename(U P i j Pw iw jw)
comm2r.code(2)
#comm2 = comm2.order(U Pw iw jw Pr ir jr)
#comm2w = comm2.rename(U P i j Pr ir jr)
comm2w.code(2)

end
</PRE>

<P>
<A NAME="IDX177"></A>

</P>
<P>
The printout of the example session. Note that systems <SAMP>`comm2w'</SAMP> and
<SAMP>`comm2r'</SAMP> are inconsistent since there is no communication when
<CODE>Pr &#60; Pw</CODE>.

</P>

<PRE>
csh&#62; lic -c
Rapid Prototyping System for Code Generation
&#62; &#60; example6
iter = [ 1 &#60;= ir &#60;= U
         1 &#60;= jr &#60;= ir - 1 ]
-1+ir-jr &#62;= 0
-1+jr &#62;= 0
-ir+U &#62;= 0
-1+ir &#62;= 0

decompr =  [ L*Pr &#60;= ir &#60; L*Pr + L ]
-1+L+L*Pr-ir &#62;= 0
-L*Pr+ir &#62;= 0
decompw =  [ L*Pw &#60;= iw &#60; L*Pw + L ]
-1+L+L*Pw-iw &#62;= 0
-L*Pw+iw &#62;= 0

lwt = [ iw = jr
        jw = ir ]
jw-ir &#62;= 0
-jw+ir &#62;= 0
iw-jr &#62;= 0
-iw+jr &#62;= 0

// Computation decomposition
#loop = { iter, decompr }
#loop = loop.order(U Pr ir jr)
#loop = loop.rename(U P i j)
loop.code(2)
for(P = 2/L; P &#60;= U/L; P++)
   for(i = max(2, L*P); i &#60;= min(-1+L+L*P, U); i++)
      for(j = 1; j &#60;= -1+i; j++)

// Communication 1
#comm1 = { iter, decompr, decompw, lwt
           [ Pr &#62; Pw ] }
#comm1 = comm1.order(U Pr ir jr Pw iw jw)
#comm1r = comm1.rename(U P i j Pw iw jw)
comm1r.code(2)

for(P = (1+L)/L; P &#60;= U/L; P++)
   for(i = L*P; i &#60;= min(-1+L+L*P, U); i++)
      for(j = 1; j &#60;= -1+L*P; j++)
         for(Pw = j/L; Pw &#60;= j/L; Pw++) {
            iw = j;
            jw = i;
         }

#comm1 = comm1.order(U Pw iw jw Pr ir jr)
#comm1w = comm1.rename(U P i j Pr ir jr)
comm1w.code(2)

for(P = 1/L; P &#60;= (-L+U)/L; P++)
   for(i = max(1, L*P); i &#60;= -1+L+L*P; i++)
      for(j = L+L*P; j &#60;= U; j++)
         for(Pr = max(j/L, (L+i)/L); Pr &#60;= j/L; Pr++) {
            ir = j;
            jr = i;
         }

// Communication 2
#comm2 = { iter, decompr, decompw, lwt
          [ Pr &#60; Pw ] }
#comm2 = comm.order(U Pr ir jr Pw iw jw)
#comm2r = comm2.rename(U P i j Pw iw jw)
comm2r.code(2)
Inconsistent inequalities
cannot find
#comm2 = comm2.order(U Pw iw jw Pr ir jr)
#comm2w = comm2.rename(U P i j Pr ir jr)
comm2w.code(2)
Inconsistent inequalities
cannot find

end
&#62; quit
done(0)

csh&#62;
</PRE>

<P>
<A NAME="IDX178"></A>

</P>
<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_14.html">previous</A>, <A HREF="lic_16.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
